#ifndef _INCLUDES_
#define _INCLUDES_

#ifdef UNIX

    // global gnu definitions

    typedef unsigned int DWORD;
    typedef unsigned short WORD;
    typedef unsigned char BYTE;
    typedef long long __int64;
    typedef unsigned long long __uint64;
    typedef int __int32;
    typedef unsigned int __uint32;
    typedef short __int16;
    typedef char __int8;
    typedef int BOOL;

    #define _GNU_SOURCE
    #include <stdlib.h>
    #include <ctype.h>
    #include <stdio.h>
    #include <string.h>
    #include <sys/time.h>
    #include <unistd.h>
    #include <iostream>
    #include <fstream>

    #define _strlwr(foo) { char *i = foo; while (*i) *i++ = tolower(*i); }
    #define strnicmp strncasecmp
    #define stricmp strcasecmp
    #define _stricmp strcasecmp
    #define _strnicmp strncasecmp
    #define _fcloseall fcloseall

#else

    // global vc++ definitions
    #define WIN32_LEAN_AND_MEAN
    #include <windows.h>
    #include <stdio.h>
    #include <conio.h>
    #include <iostream>

    #pragma warning(disable:4995)   //avoid shitty warnings from micro$oft
    #include <fstream.h>            //telling us we should use <fstream> instead
    #pragma warning(default:4995)   //but then we would have errorlist cooking over

    typedef ULONGLONG __uint64;
    typedef unsigned int __uint32;

#endif


#ifdef _DEBUG               // if DEBUG defined then support a debug stream
	extern fstream fdbg;
	#define dbgout(txt)     /*if(fdbg.is_open()) fdbg << txt;*/
	#define dbgout2(txt)    /*if(fdbg.is_open()) fdbg << txt;*/
#else
	#define dbgout(txt)
	#define dbgout2(txt)
#endif
#endif
