#ifndef _STREAMS_
#define _STREAMS_


//-----------------------------------------------------------------------------
//---= include =---------------------------------------------------------------
//-----------------------------------------------------------------------------
#include "includes.h"
#include "errors.h"
#include "lists.h"


//-----------------------------------------------------------------------------
//---= define/enum/typedef =---------------------------------------------------
//-----------------------------------------------------------------------------
//#define MAX_PATH	260			//max chars reserved 4 filenames (make it dynamic!!!)
#define MAX_FILES	16			//max files open at the same time
#define MAX_REC		1024		//maximum recursive calls
#define MAX_LINE	1024		//max chars per line
#define WRITE_BUF	1024		//write through buffer

enum
{
  FTYPE_DEFAULT,	//the thing points 2 a default file (like src-file)
  FTYPE_BINOUT,		//points to the binary output
  FTYPE_INCLUDE,	//file points 2 an include file
  FTYPE_MACRO,		//this entry points on a macro
  FTYPE_IFELSE,		//this entry points on a IF..ELSE - BLOCK

  FTYPE_MASK=63,	//mask killing buf-bit
  FTYPE_BUF,			//buf-bit means: data is in buf, otherwise fh is valid

  FTYPE_DONE = 128,
};

enum
{
  STREAM_DEFAULT,
  STREAM_THIS_FILE
};

typedef struct
{
  BYTE		type;				//file or buffer

  DWORD		last;				//holds the number of the file to return to
  //DWORD		last_line;			//line in last-file, called from
  DWORD		line_cntr;			//the pos in the file in lines 1,2,3,...
  DWORD		size;				//number of lines (for buffers)

  DWORD		error_cntr;			//holds numbers of occured errors
  DWORD		warning_cntr;		//holds numbers of occured warnings

  union
  {
    FILE	*fh;				//the filehandle
	char	*buf;				//or otherwise a pointer 2 a buffer (2xNULL 2 terminate)
  };
  union
  {
    DWORD	fofs_cntr;			//the pos in the file in bytes
	char	*pos;				//the ptr 2 actual pos in the BUFfer
  };

  char		*name;				//the filename
} FILELIST;


//-----------------------------------------------------------------------------
//---= class =-----------------------------------------------------------------
//-----------------------------------------------------------------------------
class STREAMin
{
public:
	STREAMin();
	char *line(BYTE = STREAM_DEFAULT);
	~STREAMin();

private:
	char *line_buf;			//buffer holds the entire line readden
};

class STREAMout
{
public:
	STREAMout();
	void open();
	DWORD file();
	void buf(char *, WORD);
	void opcode(__int64, WORD);
	void align(__int64);
	void flush();
	void close();
	~STREAMout();

	__int64	fofs;

private:
	FILE *fh;				//filehandle where the output goes
	char *wrt_buf;
	WORD wrt_pos;
};

class STREAM
{
public:
	STREAM();
	FILELIST *add(char *, BYTE);
	FILELIST *get();
	FILELIST *get(DWORD);
	void STREAM::close();
	~STREAM();

	STREAMin in;
	STREAMout out;

	DWORD file_no;			//the actual file for input from the FileList
	DWORD file_cntr;		//number of files open at once
	DWORD rec_cntr;			//number of open buffers (recursive calls)
	LIST *FileList;

private:
};


//-----------------------------------------------------------------------------
//---= extern =----------------------------------------------------------------
//-----------------------------------------------------------------------------
extern STREAM stream;
#endif
