#ifndef _LABELS_
#define _LABELS_


//-----------------------------------------------------------------------------
//---= include =---------------------------------------------------------------
//-----------------------------------------------------------------------------
#include "includes.h"

#include "lists.h"
#include "errors.h"


//-----------------------------------------------------------------------------
//---= define =----------------------------------------------------------------
//-----------------------------------------------------------------------------
enum
{
	LBL_TYPE_UNDEF,		//label is of undefined type (default)

	LBL_TYPE_CODE,		//align to 4 bytes, except 4 code

	LBL_TYPE_DB,		//align to 1 byte
	LBL_TYPE_DH,		//align to 2 bytes
	LBL_TYPE_DW,		//align to 4 bytes
	LBL_TYPE_DD,		//align to 8 bytes
	LBL_TYPE_DQ,		//align to 16 bytes

	LBL_TYPE_PC,		//the labels value is always the pc_cntr
	LBL_TYPE_PC_FOFS,

	LBL_TYPE_REG,		//is a definition for a r5900-register (defined by REGDEF)
	LBL_TYPE_DEFINE,	//defined by directive
	LBL_TYPE_EQUATE,

	//LBL_TYPE_LOCAL,
	LBL_TYPE_PREDEFINE,
};

enum
{
	_UNDEF_LBL = -1,
	_GLOBAL_LBL = 0,
	_LOCAL_LBL = 1
};


//-----------------------------------------------------------------------------
//---= typedef =---------------------------------------------------------------
//-----------------------------------------------------------------------------
typedef struct {

  BYTE		type;		//LBL_TYPE_xxx

  DWORD		sel_class;	//the class the label is selected
  char		*name;		//the label-name
  int		pass;		//the actual pass-cntr, when lbl is written

  __int64	value;		//the return value
  __int64	_val;		//the global value

  DWORD		file_no;	//the file-no in the file-list
  DWORD		line_cntr;	//the pos in the file in lines 1,2,3,...

} LABELLIST;


//-----------------------------------------------------------------------------
//---= class =-----------------------------------------------------------------
//-----------------------------------------------------------------------------
class LABEL
{
public:
	LABEL();
	BOOL _validate(char *);				//could string be a label (wo operators)?
	BOOL validate(char *);				//could string be a label?

	DWORD _get(char *, DWORD);
	LABELLIST *get(char *);

	DWORD add(char *, __int64, BYTE, __int8 = _UNDEF_LBL);	//add new label

	DWORD predef(char *);				//add a string 4 a label (data comes with preset)
	BOOL if_predef();
	BOOL preset(__int64, BYTE, DWORD = 0);
	~LABEL();

	LIST *LabelList;
	DWORD predef_lbl;

private:
};


//-----------------------------------------------------------------------------
//---= extern =----------------------------------------------------------------
//-----------------------------------------------------------------------------
extern LABEL label;
#endif
